import {app, ipcMain, BrowserWindow, Menu} from 'electron';
import {template} from "./menu";
import packageConfig from "../package.json";

class AppController extends Object{
    constructor(props) {
        super(props);
        app.setName(packageConfig.config.appname);
        app.on('activate', this.activate);
        app.on('ready', this.createWindow);
        app.on('window-all-closed', this.windowAllClosed);

        ipcMain.on("getAppName", event => {
            event.sender.send("returnAppName", app.getName());
        })
    }
    createWindow = () => {
        this.mainWindow = new BrowserWindow({
            webPreferences: {
                nodeIntegration: true,
            },
            width: 800, height: 600,
        });
        this.mainWindow.loadFile('./renderer/index.html')
            .then(
                () => console.log("success load front"),
                () => console.log("fail load front")
            );
        Menu.setApplicationMenu(Menu.buildFromTemplate(template));
        this.mainWindow.webContents.openDevTools({mode:"detach"});
        this.mainWindow.on('closed', ()=>{
            this.mainWindow = null;
        });
    }

    windowAllClosed = () => {
        if(process.platform !== 'darwin'){
            app.quit();
        }
    }

    activate = () => {
        if(this.mainWindow === null){
            this.createWindow();
        }
    }
}

const  myApp = new AppController();